routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\AdminController;
use App\Http\Controllers\RuanganController;
use App\Http\Controllers\DokterController;
use App\Http\Controllers\AduanController;
use App\Http\Controllers\BannerAdsController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::middleware(['auth', 'cekuser:admin'])->group(function () {
    Route::get('/', [AdminController::class, 'index']);

    Route::get('admin', [AdminController::class, 'index'])->name('home');;
    Route::resource('ruangan', RuanganController::class);
    Route::resource('dokter', DokterController::class);
    Route::post('del_dokter/{id}', [DokterController::class, 'destroy']);
    Route::get('jadwal_dokter/{dokterId}', [DokterController::class, 'editJadwal']);
    Route::post('input_jadwal/{dokterId}', [DokterController::class, 'inputJadwal']);
    
    Route::post('upload_image_ruangan', [RuanganController::class, 'uploadImage']);
    Route::get('fetch_image_ruangan/{ruanganId}', [RuanganController::class, 'fetchImage']);
    Route::get('delete_image_ruangan/{id}', [RuanganController::class, 'deleteImage']);

    Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

    Route::resource('users', App\Http\Controllers\KelolaUserController::class);
    Route::resource('banners', BannerAdsController::class);
    Route::resource('kelola_pelayanan',  App\Http\Controllers\KelolaPelayananController::class);
    Route::get('kelola-not-direct/{pelayananId}',  [App\Http\Controllers\KelolaPelayananController::class, 'showNotDirect']);
    Route::post('simpan_foto_det_pel',  [App\Http\Controllers\KelolaPelayananController::class, 'simpanFotoDetPel']);
    Route::get('delete-not-direct/{id}',  [App\Http\Controllers\KelolaPelayananController::class, 'deleteFotoDetPel']);
    Route::post('update-detail-pelayanan-not-direct',  [App\Http\Controllers\KelolaPelayananController::class, 'storeDetPelNotDirect']);
    Route::post('update_pelayanan_direct',  [App\Http\Controllers\KelolaPelayananController::class, 'simpanDirectPelayanan']);
    Route::post('update_det_pelayanan_direct',  [App\Http\Controllers\KelolaPelayananController::class, 'storeDetPelDirect']);
    Route::get('delete-direct-pelayanan/{pelayananId}',  [App\Http\Controllers\KelolaPelayananController::class, 'delDirectPelayanan']);
    Route::post('simpan_new_pelayanan',  [App\Http\Controllers\KelolaPelayananController::class, 'storeNewPelayanan']);
    Route::post('simpan_not_direct_pel/{id}',  [App\Http\Controllers\KelolaPelayananController::class, 'storeNewNotDirect']);
    
});

Route::middleware(['auth'])->group(function () {
    Route::get('pengaduan', [AduanController::class, 'index']);
    Route::get('pengaduan/{id}', [AduanController::class, 'showAduan']);
    Route::get('histori_pengaduan', [AduanController::class, 'historiAduan']);
    Route::get('fetch_data_duahari_aduan', [AduanController::class, 'fetchDataDuaHari']);
    Route::get('fetch_data_aduan', [AduanController::class, 'fetchData']);
    Route::get('get_unsoundbell', [AduanController::class, 'getUnSoundBell']);

    Route::post('mute_sound_bell', [AduanController::class, 'mutedSoundBell']);
    Route::post('action_aduan', [AduanController::class, 'actionAduan']);
    Route::get('get_aduan_by/{id}', [AduanController::class, 'getAduan']);
    Route::post('konfirmasi_aduan', [AduanController::class, 'sendKonfirmasi']);
});


Auth::routes(['register' => false]);

app/Models/Ruangan.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Ruangan extends Model
{
    use HasFactory;
    protected $connection = 'mysql';
    protected $table = 'ruangan';
    protected $fillable = [
        "nama_ruangan",
        "code_ruangan",
        "kategori",
        "deskripsi",
        "fasilitas"    
    ];
}

app/Http/Controllers/RuanganController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Ruangan;
use App\Models\DetailRuangan;
use Carbon\Carbon;

class RuanganController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $ruangan = Ruangan::all();
        return view('admin.ruangan.index', compact('ruangan'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $ruangan = Ruangan::create($request->all());
        return redirect()->back()->with('success', 'Berhasil menambahkan Data');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        return view('admin.ruangan.edit', compact('id'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }

    public function uploadImage(Request $request)
    {
        $imageType = $this->getB64Type($request->oriImage);
        if($imageType == "image/png"){
            $tipe = ".png";
        }else if($imageType == "image/jpeg"){
            $tipe = ".jpeg";
        }else{
            $tipe = ".jpg";
        }

        $url = config('global.URL_SERVER_ASSET')."upload-foto-ruangan";

        $data = array(
            "fotoRuangan" => $request->fotoRuangan, 
            "tipe_file" => $tipe
        );
        
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        $response = curl_exec($curl);
        $result = json_decode($response, true);
        $fileName = $result['message'];
        DetailRuangan::create([
            "gambar_ruangan" => $fileName,
            "ruangan_id" => $request->ruanganId
        ]);
        return response()->json([
            "code" => 200,
            "message" => "Berhasil Menambahkan Foto"
        ]);
    }

    public function getB64Type($str) {
        // $str should start with 'data:' (= 5 characters long!)
        return substr($str, 5, strpos($str, ';')-5);
    }

    public function fetchImage($id)
    {
        $detailRuangan = DetailRuangan::where('ruangan_id', $id)->get();
        return response()->json([
            "code" => 200,
            "data" => $detailRuangan
        ]);
    }

    public function deleteImage($id)
    {
        $detailRuangan = DetailRuangan::find($id);
        $detailRuangan->delete();
        return response()->json(["code" => 200]);
    }

}

resources/views/admin/ruangan/edit.blade.php
@extends('templates.main')
@section('content')
<div class="pagetitle">
    <h1>Kelola Gambar Ruangan</h1>
    <nav>
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{ url('dashboard') }}">Dashboard</a></li>
            <li class="breadcrumb-item"><a href="{{ url('ruangan') }}">Ruangan</a></li>
            <li class="breadcrumb-item active">Kelola Gambar Ruangan</li>
        </ol>
    </nav>
</div>

<section class="section">
    <div class="row">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-body">
                    <h5 class="card-title">Data Ruangan</h5>
                    <div class="row mb-3">
                        <label for="inputNumber" class="col-sm-2 col-form-label">Gambar Upload</label>
                        <div class="col-sm-10">
                            <input class="form-control" type="file" id="formFile" onchange="imageUploaded()"
                                type="file">
                        </div>
                    </div>
                    <h5 class="card-title">Daftar Foto</h5>
                    <div class="row" id="loadImage"></div>
                </div>
            </div>
        </div>
    </div>
</section>
@endsection

@push('scripts')
<script>
let base64String = "";
let oriBase64 = "";

loadImage();

function loadImage() {
    $('#loadImage').empty();
    $.ajax({
        url: '{{ url("fetch_image_ruangan/".$id) }}',
        type: 'GET',
        success: function(response) {
            response.data.forEach(e => {
                $('#loadImage').append(
                    '<div class="col-md-3"><img class="img-poli" src="{{ config("global.URL_ASSET_BARU") }}' +'poli/'+
                    e.gambar_ruangan + '" /><button type="button" onClick="deleteImage(' + e
                    .id +
                    ')" class="btn btn-sm btn-danger position-absolute" style="margin-left: -40px; margin-top: 8px;"><i class="ri-delete-bin-fill"></i></button></div>'
                );
                console.log(e.gambar_ruangan);
            });
            console.log(response);
        }
    });
}

function deleteImage(id) {
    $.ajax({
        url: '{{ url("delete_image_ruangan") }}' + '/' + id,
        type: 'GET',
        success: function(response) {
            loadImage();
        }
    });
}

function imageUploaded() {
    var file = document.querySelector(
        'input[type=file]')['files'][0];

    var reader = new FileReader();
    console.log(reader);

    reader.onload = function() {
        base64String = reader.result.replace("data:", "")
            .replace(/^.+,/, "");

        imageBase64Stringsep = base64String;
        oriBase64 = reader.result;

        // alert(imageBase64Stringsep);
        console.log(base64String);
        console.log(oriBase64);

        $.ajax({
            url: '{{ url("upload_image_ruangan") }}',
            type: 'POST',
            data: {
                oriImage: oriBase64,
                fotoRuangan: base64String,
                ruanganId: '{{ $id }}'
            },
            success: function(res) {
                console.log(res);
                loadImage();
            }
        })
    }
    reader.readAsDataURL(file);
}
</script>
@endpush

resources/views/admin/ruangan/index.blade.php
@extends('templates.main')
@section('content')
<div class="pagetitle">
    <h1>Ruangan</h1>
    <nav>
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{ url('dashboard') }}">Dashboard</a></li>
            <li class="breadcrumb-item active">Ruangan</li>
        </ol>
    </nav>
</div>
<section class="section">
    <div class="row">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-body">
                    <h5 class="card-title">Data Ruangan</h5>
                    <button type="button" class="btn btn-primary" data-bs-toggle="modal" data-bs-target="#basicModal">
                        Tambah Data
                    </button>
                    <table class="table" id="datatable">
                        <thead>
                            <tr>
                                <th>
                                    No
                                </th>
                                <th>
                                    Kode
                                </th>
                                <th>
                                    Ruangan
                                </th>
                                <th>
                                    Kategori
                                </th>
                                <th>
                                    Aksi
                                </th>
                            </tr>
                        </thead>
                        <tbody>
                            @php $no = 0; @endphp
                            @foreach($ruangan as $row)
                            @php $no++; @endphp
                            <tr>
                                <td>
                                    {{ $no }}
                                </td>
                                <td>
                                    {{ $row->code_ruangan }}
                                </td>
                                <td>
                                    {{ $row->nama_ruangan }}
                                </td>
                                <td>
                                    {{ $row->kategori }}
                                </td>
                                <td>
                                    <a href="{{ route('ruangan.edit', $row->id) }}"
                                        class="btn btn-primary btn-sm">
                                        <i class="ri-camera-fill"></i></a>
                                </td>
                            </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</section>
<div class="p-6 w-full bg-white rounded border border-gray-200 shadow-md dark:bg-gray-800 dark:border-gray-700">
    <div class="modal fade" id="basicModal" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Tambah Data</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    <form action="{{ route('ruangan.store') }}">
                        @csrf
                        <div class="row mb-3">
                            <label for="inputText" class="col-sm-2 col-form-label">Kode Ruangan</label>
                            <div class="col-sm-10">
                                <input type="text" id="code_ruangan" name="code_ruangan" class="form-control"
                                    required />
                            </div>
                        </div>
                        <div class="row mb-3">
                            <label for="inputText" class="col-sm-2 col-form-label">Ruangan</label>
                            <div class="col-sm-10">
                                <input type="text" id="nama_ruangan" name="nama_ruangan" class="form-control"
                                    required />
                            </div>
                        </div>
                        <div class="row mb-3">
                            <label for="inputText" class="col-sm-2 col-form-label">Kategori</label>
                            <div class="col-sm-10">
                                <select class="form-select" id="kategori" name="kategori" required>
                                    <option name="POLI">Poli</option>
                                    <option name="RANAP">Rawat Inap</option>
                                </select>
                            </div>
                        </div>
                        <div class="row mb-3">
                            <label for="inputText" class="col-sm-2 col-form-label">Deskripsi</label>
                            <div class="col-sm-10">
                                <textarea id="deskripsi" name="deskripsi" class="form-control" required></textarea>
                            </div>
                        </div>
                        <div class="row mb-3">
                            <label for="inputText" class="col-sm-2 col-form-label">Fasilitas</label>
                            <div class="col-sm-10">
                                <textarea id="fasilitas" name="fasilitas" class="form-control" required></textarea>
                            </div>
                        </div>
                        <button type="submit" class="btn btn-primary">Submit</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>

@endsection

@push('scripts')
<script>
$("#datatable").DataTable();

const btnTambah = document.querySelector("#btnTambah");
btnTambah.addEventListener("click", function() {
    $("#judulModal").text("Tambah Data");
});
</script>
@endpush